| Flutter Impeller |

Public Member Functions | Static Public Member Functions | List of all members
impeller::DlImageImpeller Class Referencefinal

`#include <dl_image_impeller.h>`

Inheritance diagram for impeller::DlImageImpeller:

## Public Member Functions
| ~DlImageImpeller () override
sk_sp< SkImage > | skia_image () const override
std::shared_ptr< impeller::Texture > | impeller_texture () const override
bool | isOpaque () const override
bool | isTextureBacked () const override
bool | isUIThreadSafe () const override
flutter::DlISize | GetSize () const override
size_t | GetApproximateByteSize () const override
OwningContext | owning_context () const override

## Static Public Member Functions
static sk_sp< DlImageImpeller > | Make (std::shared_ptr< Texture > texture, OwningContext owning_context=OwningContext::kIO)
static sk_sp< DlImageImpeller > | MakeFromYUVTextures (AiksContext *aiks_context, std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)

## Detailed Description

Definition at line 15 of file dl_image_impeller.h.

## Constructor & Destructor Documentation

## ◆ ~DlImageImpeller()

impeller::DlImageImpeller::~DlImageImpeller | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ GetApproximateByteSize()

size_t impeller::DlImageImpeller::GetApproximateByteSize | ( |  | ) | const
| override

Definition at line 122 of file dl_image_impeller.cc.

122 {
123 auto size = sizeof(*this);
124 if (texture_) {
125 size += texture_->GetTextureDescriptor().GetByteSizeOfBaseMipLevel();
126 }
127 return size;
128 }

## ◆ GetSize()

flutter::DlISize impeller::DlImageImpeller::GetSize | ( |  | ) | const
| override

Definition at line 115 of file dl_image_impeller.cc.

115 {
116 // texture |GetSize()| returns a 64-bit size, but we need a 32-bit size,
117 // so we need to convert to DlISize (the 32-bit variant) either way.
118 return texture_ ? flutter::DlISize(texture_->GetSize()) : flutter::DlISize();
119 }
flutter
Definition: dl_golden_blur_unittests.cc:16

## ◆ impeller_texture()

std::shared_ptr< impeller::Texture > impeller::DlImageImpeller::impeller_texture | ( |  | ) | const
| override

Definition at line 92 of file dl_image_impeller.cc.

92 {
93 return texture_;
94 }

## ◆ isOpaque()

bool impeller::DlImageImpeller::isOpaque | ( |  | ) | const
| override

Definition at line 97 of file dl_image_impeller.cc.

97 {
98 // Impeller doesn't currently implement opaque alpha types.
99 return false;
100 }

## ◆ isTextureBacked()

bool impeller::DlImageImpeller::isTextureBacked | ( |  | ) | const
| override

Definition at line 103 of file dl_image_impeller.cc.

103 {
104 // Impeller textures are always ... textures :/
105 return true;
106 }

## ◆ isUIThreadSafe()

bool impeller::DlImageImpeller::isUIThreadSafe | ( |  | ) | const
| override

Definition at line 109 of file dl_image_impeller.cc.

109 {
110 // Impeller textures are always thread-safe
111 return true;
112 }

## ◆ Make()

sk_sp< DlImageImpeller > impeller::DlImageImpeller::Make | ( | std::shared_ptr< Texture > | texture,
|  | OwningContext | owning_context = `OwningContext::kIO`
| ) |  |
| static

Definition at line 23 of file dl_image_impeller.cc.

24 {
25 if (!texture) {
26 return nullptr;
27 }
28 return sk_sp<DlImageImpeller>(
29 new DlImageImpeller(std::move(texture), owning_context));
30 }
impeller::DlImageImpeller::owning_context
OwningContext owning_context() const override
Definition: dl_image_impeller.h:57

References owning_context().

Referenced by impeller::DlPlayground::CreateDlImageForFixture(), impeller::GoldenPlaygroundTest::CreateDlImageForFixture(), MakeFromYUVTextures(), impeller::interop::Texture::MakeImage(), impeller::interop::ReadSamplersAndUniforms(), and impeller::testing::TEST_P().

## ◆ MakeFromYUVTextures()

sk_sp< DlImageImpeller > impeller::DlImageImpeller::MakeFromYUVTextures | ( | AiksContext * | aiks_context,
|  | std::shared_ptr< Texture > | y_texture,
|  | std::shared_ptr< Texture > | uv_texture,
|  | YUVColorSpace | yuv_color_space
| ) |  |
| static

Definition at line 33 of file dl_image_impeller.cc.

37 {
38 if (!aiks_context || !y_texture || !uv_texture) {
39 return nullptr;
40 }
41 auto yuv_to_rgb_filter_contents = FilterContents::MakeYUVToRGBFilter(
42 std::move(y_texture), std::move(uv_texture), yuv_color_space);
43 impeller::Entity entity;
44 entity.SetBlendMode(impeller::BlendMode::kSrc);
45
46 // Disable the render target cache so that this snapshot's texture will not
47 // be reused later by other operations.
48 const auto& renderer = aiks_context->GetContentContext();
49 renderer.GetRenderTargetCache()->DisableCache();
50 fml::ScopedCleanupClosure restore_cache(
51 [&] { renderer.GetRenderTargetCache()->EnableCache(); });
52
53 std::optional<Snapshot> snapshot =
54 yuv_to_rgb_filter_contents->RenderToSnapshot(
55 renderer, entity,
56 {.coverage_limit = std::nullopt,
57 .sampler_descriptor = std::nullopt,
58 .msaa_enabled = true,
59 .mip_count = 1,
60 .label = "MakeYUVToRGBFilter Snapshot"});
61 if (!snapshot.has_value()) {
62 return nullptr;
63 }
64 return impeller::DlImageImpeller::Make(snapshot->texture);
65 }
impeller::DlImageImpeller::Make
static sk_sp< DlImageImpeller > Make(std::shared_ptr< Texture > texture, OwningContext owning_context=OwningContext::kIO)
Definition: dl_image_impeller.cc:23
impeller::Entity
Definition: entity.h:26
impeller::Entity::SetBlendMode
void SetBlendMode(BlendMode blend_mode)
Definition: entity.cc:98
impeller::FilterContents::MakeYUVToRGBFilter
static std::shared_ptr< FilterContents > MakeYUVToRGBFilter(std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)
Definition: filter_contents.cc:109
impeller::BlendMode::kSrc
@ kSrc

References impeller::AiksContext::GetContentContext(), impeller::ContentContext::GetRenderTargetCache(), impeller::kSrc, Make(), impeller::FilterContents::MakeYUVToRGBFilter(), and impeller::Entity::SetBlendMode().

## ◆ owning_context()

OwningContext impeller::DlImageImpeller::owning_context | ( |  | ) | const
| inlineoverride

Definition at line 57 of file dl_image_impeller.h.

57 { return owning_context_; }

Referenced by Make().

## ◆ skia_image()

sk_sp< SkImage > impeller::DlImageImpeller::skia_image | ( |  | ) | const
| override

Definition at line 87 of file dl_image_impeller.cc.

87 {
88 return nullptr;
89 };

The documentation for this class was generated from the following files:

- impeller/display_list/dl_image_impeller.h
- impeller/display_list/dl_image_impeller.cc